# This file is a template, and might need editing before it works on your project.
# see https://docs.gitlab.com/ce/ci/yaml/README.html for all available options

# you can delete this line if you're not using Docker
image: busybox:latest

before_script:
  - echo "Before script section"
  - echo "For example you might run an update here or install a build dependency"
  - echo "Or perhaps you might print out some debugging details"

after_script:
  - echo "After script section"
  - echo "For example you might do some cleanup here"

build1:
  stage: build
  image: devth/helm
  script:
    - deploy_mock
    - echo "Do your build here" 

test1:
  stage: test
  script:
    - echo "Do a test here"
    - echo "For example run a test suite"

test2:
  stage: test
  script:
    - echo "Do another parallel test here"
    - echo "For example run a lint test"

deploy1:
  stage: deploy
  script:
    - echo "Do your deploy here"

.bash_funcs: &bash_funcs |
  # Bash Script variables and functions
  
  function deploy_mock() {
    export folder_mock=`ls $CI_PROJECT_DIR | grep mock`
    if [ ! -z "$folder_mock" ]; then
      echo "Instaling mocks"
      if [ "$folder_mock" == "soapui-mock" ]; then
        #apk add py-pip
        cd $CI_PROJECT_DIR/ci-cd/worker-z/dev/lib/mockJoin
        pip install --user -r requirements
        pwd
        python app.py "http-z-imdb" "$CI_PROJECT_DIR"
      fi

      echo "kubectl create configmap $folder_mock-$RELEASE_NAME --namespace=mock --from-file=$CI_PROJECT_DIR/$folder_mock -o yaml --dry-run | kubectl apply -f -"
      helm_cmd="helm upgrade --install --recreate-pods --namespace mock \
          --set name=$RELEASE_NAME-mock \
          --set release=$RELEASE_NAME \
          --namespace=mock \
          --force --wait \
          $RELEASE_NAME-mock \
          $CI_PROJECT_DIR/../ci-cd/worker-z/dev/k8s/$folder_mock"
      echo $helm_cmd
    fi
  }

before_script:
  - *bash_funcs